
%OBS: Bruk smoothing splines: Smoothness ca 0.08, f = fit(month, pressure,  'smoothingspline', 'SmoothingParam', 0.08)
clear all;
fil1= load('ti.txt');
fil2 = load('tjue.txt');
%fil3 = load('tretti.txt');

dataFil = [fil1;fil2]; 
imax= length(dataFil);
y=dataFil(1:imax,2);
timestamp=dataFil(1:imax,1)/1000;


% Reversere data:
%{x
for i=1:length(dataFil)
    y(i,1)= 5 - dataFil(i,2);
end
%}

h = fir1(500,1/72*2,'high'); 
% filter out DC
y_filt=filter(h,1,y);
% square it
detsq = y_filt .^ 2;


% let's detect the momentary heart rate in beats per min
last=0;
upflag=0;
prePulse=zeros(length(detsq),1);
%avg_puls=zeros(length(detsq),1);
p=60;

% PULSE Calculations
for i = 1:length(detsq)
    if (detsq(i) > 0.5)
        if (upflag == 0)
            if (last > 0)
               t = timestamp(i) - last;
               p = uint8(60/t);
            end
            last =timestamp(i);
        
        end
        upflag = 35;
    else
        if (upflag>0)
            upflag = upflag - 1;
        end
    end
    prePulse(i)=p;
end

pulse=zeros(length(prePulse),2);
pulse(1,2)=prePulse(1);
pulse(1,1)=timestamp(1);
for i=2:length(prePulse)
    if (prePulse(i)~= prePulse(i-1))
        pulse(i,1) = timestamp(i);
        pulse(i,2) = prePulse(i);
    end
end

pulse( ~any(pulse,2), : ) = [];
heartRate=pulse(:,2);
time=pulse(:,1);


fit1 = fit(time, heartRate, 'smoothingspline', 'SmoothingParam', 0.0005);

I=[]; %zeros(length(heartRate),1);
a=zeros(30,1);

for j=30:30:(length(heartRate))
 
    v=heartRate(j-29:j);
    medi=median(v);
%  a ~= v > 1.3*medi 
%     for k=1:20
        a= abs(v-medi) > 2*std(v);
%        if (abs(v(k)-mean(v)) > 1.5*std(v))
%              I(end+1)=v(k);
%        end
%     end
    I=[I;a];
end
I=logical(I);


outliers = excludedata(time,heartRate,'indices',I);
fit2 = fit(time, heartRate, 'smoothingspline', 'SmoothingParam', 0.0005, 'Exclude', outliers);

% SAVE STUFF
%{
save('pulse.mat', 'pulse');
save('indices.mat', 'I');
%}
%{
figure('Color',[0.8 0.8 0.8]);
plot(fit2, 'r-', time, heartRate, 'k.', outliers, 'm*')
 hold on
plot(fit1,'b--')
p_legend=legend('Pulse measurement', 'Excluded data', 'Trendline, outliers excluded', 'Old trendline');
set(p_legend,'FontSize', 18);
line([240, 240],[30,110])
line([480, 480],[30,110])
line([720, 720],[30,110])
line([960, 960],[30,110])
refline(0,60)
refline(0,70)
%refline(0,80)
title('Heart rate, outliers excluded Subject nr. 3','FontSize',16)
xlabel('Run-time [s]','FontSize',16)
ylabel('Heart rate [BPM]','FontSize',16)
set(gca,'Color',[0.941 0.917 0.839],'linewidth',1.5);

%}
%savefig('pulsePlot.fig')
% PLOT Y
%{ 
figure('Color',[0.8 0.8 0.8]);
plot(timestamp,y)
set(gca,'Color',[0.941 0.917 0.839])
legend('ECG-signal')
xlabel('Time')
ylabel('Signal strength [v]')
%xlim([450,460])
title('ECG signal  Subject nr. 3')

%}

% PLOT Y_FILT
%{
figure
plot(y_filt)
title('Y-Filt')
%}

% PLOT detsq
%{
figure('Color',[0.8 0.8 0.8]);
h=subplot(1,1,1);
plot(timestamp,detsq)
set(h,'Color',[0.941 0.917 0.839])
legend('Filtered signal')
xlabel('Run-time [s]')
ylabel('Signal')
%xlim([450,460])
title('Filtered signal  Subject nr. 3')

%}

% PLOT PULSE
%{ 
figure('Color',[0.8 0.8 0.8]);
plot(timestamp,prePulse)
set(gca,'Color',[0.941 0.917 0.839])
refline(0,60)
refline(0,70)
refline(0,80)
title('Heart-rate Subject nr 3','FontSize',14)
xlabel('Run-time [s]','FontSize',14)
ylabel('Heart rate [BPM]','FontSize',14)
legend('Momentary heart rate')
%}
%{
figure('Color',[0.8 0.8 0.8]);
plot(fit1, 'b-', time, heartRate, 'k.')
h_legend=legend('Pulse measurement', 'Trendline');
set(h_legend,'FontSize', 18);
line([240, 240],[30,110])
line([480, 480],[30,110])
line([720, 720],[30,110])
line([960, 960],[30,110])
refline(0,60)
refline(0,70)
%refline(0,80)
title('Heart rate Subject nr. 3','FontSize',16)
xlabel('Run-time [s]','FontSize',16)
ylabel('Heart rate [BPM]','FontSize',16)
set(gca,'Color',[0.941 0.917 0.839]);
%}




