clear all
%load('c:\Users\PLM\Dropbox\Arduino\MATLAB\testdata\mean_and_slope.mat');
%load('c:\Users\PLM\Dropbox\Arduino\MATLAB\testdata\Ttests.mat');
load('mean_and_slope.mat');
load('Ttests.mat');
% data: 1, 4, 7, 10 og 13 = middelverdi
% data: 2, 5, 8, 11 og 14 = std for middelverdien
% data: 3, 6, 9, 12 og 15 = slope

% Remove samples with clear errors
%{x
removeSample=zeros(length(data),1);
removeSample([12 13 14 20 28 36])=1;
removeSample=logical(removeSample);
data(removeSample, :)=[];
Ttestdata(removeSample, :)=[];
%}
my1=data(:,1);my2=data(:,4);my3=data(:,7);my4=data(:,10);my5=data(:,13);
allmys=[my1,my2,my3,my4,my5];

delta12=my1-my2;delta13=my1-my3; delta14=my1-my4; delta15=my1-my5;
delta23=my2-my3; delta24=my2-my4; delta25=my2-my5;
delta34=my3-my4; delta35=my3-my5;
delta45=my4-my5;
% gjennomsnitt av intervall 1 og 5 mot intervall 3
%delta153=(my1+my5)/2 -my3; 
% gjennomsnitt av intervall 2 og 4 mot intervall 3
%delta243=(my2+my4)/2-my3;



deltas=[delta12, delta13, delta14, delta15, delta23, delta24,...
    delta25, delta34, delta35, delta45];

% Calculate number of tests with positive, neutral, or negative slope  
%(1st interval)
%{
slope0=data(:,3)*100;
positiveSlope=0;
negativeSlope=0;
neutralS=0;
for i=1:length(data)
    if (slope0(i) < -1)
        positiveSlope=positiveSlope+1;
    
    elseif (slope0(i) > 1)
        negativeSlope=negativeSlope + 1;
    else
        neutralS = neutralS+1;
    end
end
%}
% Produce scatterplot and histograms
%{
    %{
v=zeros(length(data),1);
for k=1:length(data)
    v(k)=k;
end

pl=zeros(3,3);
figure('Color',[0.8 0.8 0.8]);
for i=1:9
    navn=strcat('Delta ',num2str(i));
    pl(i)=subplot(3,3,i);
    plot(deltas(:,i),v,'*')
    xlim([-12,12])
    title(navn)
end
set(pl,'Color',[0.941 0.917 0.839])
    %}
hist=zeros(2,5);
figure('Color',[0.8 0.8 0.8]);
for i=1:10
    navn=strcat('Delta ',num2str(i));
    hist(i)=subplot(2,5,i);
    histfit(deltas(:,i),20)
    xlim([-18,18])
   % plotter linje for middelverdien til Delta
    [muhat,sigmahat] = normfit(deltas(:,i));
    hold on; 
    plot([muhat muhat],[0 8],'g','linewidth',1.5);
    title(navn)
end
set(hist,'Color',[0.941 0.917 0.839])
%}
% ttest sjekker om gjennomsnittet av dataene er normalfordelt og = 0, H=0
% hvis gjennomsnittet av Delta = 0, H=1 hvis gjennomsinttet ikke er lik 0,
% ttest2 sjekker om gjennomsinttet av data 1 er lik gjennomsnitt av data 2
% H=0 hvis gjennomsnitt av my 1 = gjennomsnitt av my2, H=1 hvis de er ulike
% ttest 2 tar kanskje bedre vare p variansen?
% t-tests, right sided
results=zeros(10,8);
for i=1:10
    [h,p,ci,stats]=ttest(deltas(:,i),0,'Tail','right');
    results(i,1)=h;
    results(i,2)=p;
    results(i,3)=ci(1);
    results(i,4)=mean(deltas(:,i));
    results(i,5)=ci(2);
    results(i,6)=stats.tstat;
    results(i,7)=stats.df;
    results(i,8)=stats.sd;
end
B={'Delta 12','Delta 13','Delta 14','Delta 15','Delta 23','Delta 24',...
    'Delta 25','Delta 34','Delta 35','Delta 45'};    
boxplot(deltas,B,'notch','on')
%refrefline(0,0)
%{
[h0,p0,ci0,stats0]=ttest(delta12);
[h1,p1]=ttest(delta13); %,0,'Tail','right'
[h2,p2]=ttest(delta14);
[h3,p3]=ttest(delta15);
[h4,p4]=ttest(delta23);
[h5,p5]=ttest(delta24);
[h6,p6]=ttest(delta25);
[h7,p7]=ttest(delta34);
[h8,p8]=ttest(delta35);
[h9,p9]=ttest(delta45);

    
alleH=[h0,p0;h1,p1;h2,p2;h3,p3;h4,p4;h5,p5;h6,p6;h7,p7;h8,p8;h9,p9];
%}

