#include <Wire.h>
#include <eHealth.h>
#include <SFE_MMA8452Q.h>
#include <SD.h>

//ECG - declare variables
float ECGsignal;
unsigned long timestamp;
String filNavn;
//Accelerometer - class instance
MMA8452Q aks;


// Sparkfun SD shield: pin 8
const int chipSelect = 8;


void setup()
{
  Serial.begin(9600);
  Serial.println("Test supercode with accelerometer and ECG!");
  // make sure that the default chip select pin is set to
  // output, even if you don't use it:
  pinMode(10, OUTPUT);
   // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    return;
    }
  aks.init(SCALE_2G, ODR_6);
  ECGsignal=eHealth.getECG();
  Serial.println(ECGsignal);
 }

void loop()
{
  timestamp = millis();   
  
  if (timestamp <= 600000) {
    filNavn = "ti.txt";
  }
   else if (timestamp > 600000, timestamp <= 1200000) {
    filNavn ="tjue.txt";
  }
    else if (timestamp > 1200000 && timestamp <= 1800000) {
    filNavn ="tretti.txt";
  }
  else  {
    filNavn ="overTretti.txt";
  }
     
  char navn[filNavn.length()+1];
     filNavn.toCharArray(navn, sizeof(navn));
      
     File csvFile = SD.open(navn, FILE_WRITE);
    
  if(csvFile){
      
     ECGsignal=eHealth.getECG();
     aks.read();
  
     csvFile.print(timestamp);
     csvFile.print(";");
     csvFile.print(ECGsignal);
     csvFile.print(";");
     csvFile.print(aks.cx, 3); 
     csvFile.print(";");
     csvFile.print(aks.cy, 3); 
     csvFile.print(";");
     csvFile.print(aks.cz, 3); 
     csvFile.println(";");
     
     
     csvFile.close();
     }
 else{
   Serial.println("wtf, shit ain't working");
 }
    //koden bruker ca 14 ms uten delay, gir 72 målinger per s
    //delay(11); // delay 11  gir run time ca 25 ms, 40 målinger per sekund
    }
